/****************************************************************/
/* Copyright (C) 2004 TomTom BV. All Rights Reserved.           */
/* Author: J. Taverne                                           */
/****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "MD5.h"
#include "Blowfish.h"

#define RAMDISK_ADDRESS 0x31000000
#define LINUX_ADDRESS   0x31700000

int main(int argc,char **argv)
{
    MD5_CTX context;
    FILE *infptr;
    FILE *outfptr;
    unsigned int index;
    unsigned int size;
    unsigned int address;
    unsigned char file;
    unsigned char data;
    unsigned char id[4]="TTBL";
    BLOWFISH_CTX ctx;
    unsigned char key[]={0xD8,0x88,0xD3,0x13,0xED,0x83,0xBA,0xAD,0x9C,0xF4,0x1B,0x50,0xB3,0x43,0xFA,0xDD};

    // Empty FLASH
    /* Welcome message */
    fprintf(stderr,"MakeImage $Revision: 1.3 $, (C) 2004 TomTom B.V. J.Taverne\n");

    /* Check arguments */
    if (argc != 4) 
    {
        fprintf(stderr,"Usage: %s <output file> <ramdisk file> <zimage file>\n",argv[0]);
        exit(-1);
    }

    /* Open file */
    if ((outfptr = fopen(argv[1],"wb")) == NULL) 
    {
        fprintf(stderr,"Unable to create file \"%s\"\n",argv[1]);
        exit(-1);
    }
    
    // Write ID TomTom BootLoader "TTBL"
    fwrite(id,4,1,outfptr);

    // Generate and write header
    for (file=0;file<2;file++)
    {
        /* Open file */
        if ((infptr = fopen(argv[file+2],"rb")) == NULL) 
        {
             fprintf(stderr,"Unable to open file \"%s\"\n",argv[file+2]);
             exit(-1);
        }

        // Get filesize
        fseek(infptr,0,SEEK_END); 
        size = ftell(infptr);           
        fseek(infptr,0,SEEK_SET);  

        // Write little endian filesize
        fwrite(&size,4,1,outfptr);

        // Determine address
        if (file == 1) address = LINUX_ADDRESS; else address = RAMDISK_ADDRESS;
        
        // Write little endian address
        fwrite(&address,4,1,outfptr);

        MD5Init(&context,0);

        // Write image and calculate MD5
        for (index=0;index<size;index++)
        {
            fread(&data,1,1,infptr);
            MD5Update(&context,&data,1);
            fwrite(&data,1,1,outfptr);
        }
    
        MD5Final(&context);

        // Calculate blowfish
        Blowfish_Init (&ctx,key, 16);
        Blowfish_Encrypt(&ctx, &context.buf[0], &context.buf[1]);
        Blowfish_Encrypt(&ctx, &context.buf[2], &context.buf[3]);

        // Write little endian blowfish
        fwrite(context.buf,16,1,outfptr);

        Blowfish_Decrypt(&ctx, &context.buf[0], &context.buf[1]);
        Blowfish_Decrypt(&ctx, &context.buf[2], &context.buf[3]);

        fclose(infptr);
    }

    // Write little endian filesize 0 as endmark
    size = 0;           
    fwrite(&size,4,1,outfptr);

    // Write startaddress
    address = LINUX_ADDRESS;
    fwrite(&address,4,1,outfptr);

    // Write mem config structure address
    address = 0x30000000;
    fwrite(&address,4,1,outfptr);

    fclose(outfptr);

    return 0;
}

